% This code generates Figure 6d and/or Supplementary Figure S8d from oude Lohuis et al., 2022.
% This code uses the data structure "BehLat" generated by the code named:
% "Build_BehLat" and stored in the folder "Data6_3"
% Dprimes from all sessions are collected and plotted for different
% conditions, statistical test are performed and p-values computed.
% For any questions contact Umberto Olcese at u.olcese@uva.nl

%% Prep
sessionnames = categorical({BehLat.SessionName});
sessionnum = double(sessionnames);


%% Low saliency visual contra
figure(); hold on

%UST mice ----------------------------------------------------------------
%Control
Cu = [BehLat(strcmp({BehLat.Side},'Contra') & strcmp({BehLat.Modality},'Visual') & strcmp({BehLat.Task},'tUni') & strcmp({BehLat.Silencing},'Early') & strcmp({BehLat.Saliency},'Low')).DprimeCtrl]; %Added early only for unisensory since same sessions for control, late and early silencing
%Early silencing
Eu = [BehLat(strcmp({BehLat.Side},'Contra') & strcmp({BehLat.Modality},'Visual') & strcmp({BehLat.Task},'tUni') & strcmp({BehLat.Silencing},'Early') & strcmp({BehLat.Saliency},'Low')).Dprime];
%Late silencing
Lu = [BehLat(strcmp({BehLat.Side},'Contra') & strcmp({BehLat.Modality},'Visual') & strcmp({BehLat.Task},'tUni') & strcmp({BehLat.Silencing},'Late') & strcmp({BehLat.Saliency},'Low')).Dprime];
%Plot: median with errorbars: 25th and 75th percentiles
errorbar([1 2],[nanmedian(Cu) nanmedian(Eu)],[abs(nanmedian(Cu)-prctile(Cu,25)) abs(nanmedian(Eu)-prctile(Eu,25))], [abs(nanmedian(Cu)-prctile(Cu,75)) abs(nanmedian(Eu)-prctile(Eu,75)) ],'Color',[1 .7 .3],'LineWidth',3)
errorbar([1.15 3.15],[nanmedian(Cu) nanmedian(Lu)],[abs(nanmedian(Cu)-prctile(Cu,25)) abs(nanmedian(Lu)-prctile(Lu,25))], [abs(nanmedian(Cu)-prctile(Cu,75)) abs(nanmedian(Lu)-prctile(Lu,75))],'Color',[1 .7 .3],'LineWidth',3)

%MST mice ---------------------------------------------------------------
% For MST, the Early and Late sessions are different. We can
% only compare Early-Ctrl (subselection) and Late-Ctrl(subselection) that belong to the
% same session
Cmfilt = strcmp({BehLat.Side},'Contra') & strcmp({BehLat.Modality},'Visual') & strcmp({BehLat.Task},'tMulti') & strcmp({BehLat.Saliency},'Low');
Emfilt = strcmp({BehLat.Side},'Contra') & strcmp({BehLat.Modality},'Visual') & strcmp({BehLat.Task},'tMulti') & strcmp({BehLat.Silencing},'Early') & strcmp({BehLat.Saliency},'Low');
Lmfilt = strcmp({BehLat.Side},'Contra') & strcmp({BehLat.Modality},'Visual') & strcmp({BehLat.Task},'tMulti') & strcmp({BehLat.Silencing},'Late') & strcmp({BehLat.Saliency},'Low');
Cm = [BehLat(Cmfilt).DprimeCtrl];
Em = [BehLat(Emfilt).Dprime];
Lm = [BehLat(Lmfilt).Dprime];
%Subselect for control condition
Cme = [BehLat( Cmfilt & ismember(sessionnum,sessionnum(Emfilt))  ).DprimeCtrl];
Cml = [BehLat( Cmfilt & ismember(sessionnum,sessionnum(Lmfilt))  ).DprimeCtrl];
%Plot
errorbar([1.1 2.1], [nanmedian(Cme) nanmedian(Em)], [abs(nanmedian(Cme)-prctile(Cme,25)) abs(nanmedian(Em)-prctile(Em,25))], [abs(nanmedian(Cme)-prctile(Cme,75)) abs(nanmedian(Em)-prctile(Em,75))],'Color',[.8 0 .8],'LineWidth',3)
errorbar([1.2 3.2], [nanmedian(Cml) nanmedian(Lm)], [abs(nanmedian(Cml)-prctile(Cml,25)) abs(nanmedian(Lm)-prctile(Lm,25))], [abs(nanmedian(Cml)-prctile(Cml,75)) abs(nanmedian(Lm)-prctile(Lm,75))],'Color',[.8 0 .8],'LineWidth',3)

%Figure format -----------------------------------------------------------
xlim([0 4])
ylim([-0.5 2.8])
xticks([1 2 3])
xticklabels({'Ctrl','Early','Late'})
title('Low saliency right-side visual trials')
legend({'UST early','UST late','MST early','MST late'})

%Stats -------------------------------------------------------------------
%Now done with LME

%% High saliency visual contra
figure(); hold on

%UST mice ----------------------------------------------------------------
%Control
Cu = [BehLat(strcmp({BehLat.Side},'Contra') & strcmp({BehLat.Modality},'Visual') & strcmp({BehLat.Task},'tUni') & strcmp({BehLat.Silencing},'Early') & strcmp({BehLat.Saliency},'High')).DprimeCtrl]; %Added early only for unisensory since same sessions for control, late and early silencing
%Early silencing
Eu = [BehLat(strcmp({BehLat.Side},'Contra') & strcmp({BehLat.Modality},'Visual') & strcmp({BehLat.Task},'tUni') & strcmp({BehLat.Silencing},'Early') & strcmp({BehLat.Saliency},'High')).Dprime];
%Late silencing
Lu = [BehLat(strcmp({BehLat.Side},'Contra') & strcmp({BehLat.Modality},'Visual') & strcmp({BehLat.Task},'tUni') & strcmp({BehLat.Silencing},'Late') & strcmp({BehLat.Saliency},'High')).Dprime];
%Plot
errorbar([1 2],[nanmedian(Cu) nanmedian(Eu)],[abs(nanmedian(Cu)-prctile(Cu,25)) abs(nanmedian(Eu)-prctile(Eu,25))], [abs(nanmedian(Cu)-prctile(Cu,75)) abs(nanmedian(Eu)-prctile(Eu,75)) ],'Color',[1 .7 .3],'LineWidth',3)
errorbar([1.15 3.15],[nanmedian(Cu) nanmedian(Lu)],[abs(nanmedian(Cu)-prctile(Cu,25)) abs(nanmedian(Lu)-prctile(Lu,25))], [abs(nanmedian(Cu)-prctile(Cu,75)) abs(nanmedian(Lu)-prctile(Lu,75))],'Color',[1 .7 .3],'LineWidth',3)

%MST mice ----------------------------------------------------------------
%Same as previously
Cmfilt = strcmp({BehLat.Side},'Contra') & strcmp({BehLat.Modality},'Visual') & strcmp({BehLat.Task},'tMulti') & strcmp({BehLat.Saliency},'High');
Emfilt = strcmp({BehLat.Side},'Contra') & strcmp({BehLat.Modality},'Visual') & strcmp({BehLat.Task},'tMulti') & strcmp({BehLat.Silencing},'Early') & strcmp({BehLat.Saliency},'High');
Lmfilt = strcmp({BehLat.Side},'Contra') & strcmp({BehLat.Modality},'Visual') & strcmp({BehLat.Task},'tMulti') & strcmp({BehLat.Silencing},'Late') & strcmp({BehLat.Saliency},'High');
Cm = [BehLat(Cmfilt).DprimeCtrl];
Em = [BehLat(Emfilt).Dprime];
Lm = [BehLat(Lmfilt).Dprime];
Cme = [BehLat( Cmfilt & ismember(sessionnum,sessionnum(Emfilt))  ).DprimeCtrl];
Cml = [BehLat( Cmfilt & ismember(sessionnum,sessionnum(Lmfilt))  ).DprimeCtrl];
errorbar([1.1 2.1], [nanmedian(Cme) nanmedian(Em)], [abs(nanmedian(Cme)-prctile(Cme,25)) abs(nanmedian(Em)-prctile(Em,25))], [abs(nanmedian(Cme)-prctile(Cme,75)) abs(nanmedian(Em)-prctile(Em,75))],'Color',[.8 0 .8],'LineWidth',3)
errorbar([1.2 3.2], [nanmedian(Cml) nanmedian(Lm)], [abs(nanmedian(Cml)-prctile(Cml,25)) abs(nanmedian(Lm)-prctile(Lm,25))], [abs(nanmedian(Cml)-prctile(Cml,75)) abs(nanmedian(Lm)-prctile(Lm,75))],'Color',[.8 0 .8],'LineWidth',3)

%Figure format -----------------------------------------------------------
xlim([0 4])
ylim([-0.5 2.8])
xticks([1 2 3])
xticklabels({'Ctrl','Early','Late'})
title('High saliency right-side visual trials')
legend({'UST early','UST late','MST early','MST late'})

%Stats -------------------------------------------------------------------
%Now done with LME

%% Low saliency visual ipsi
figure(); hold on

%UST mice ----------------------------------------------------------------
%Control
Cu = [BehLat(strcmp({BehLat.Modality},'Visual') & strcmp({BehLat.Side},'Ipsi') & strcmp({BehLat.Task},'tUni') & strcmp({BehLat.Silencing},'Early') & strcmp({BehLat.Saliency},'Low')).DprimeCtrl]; %Added early only for unisensory since same sessions for control, late and early silencing
%Early silencing
Eu = [BehLat(strcmp({BehLat.Modality},'Visual') & strcmp({BehLat.Side},'Ipsi') & strcmp({BehLat.Task},'tUni') & strcmp({BehLat.Silencing},'Early') & strcmp({BehLat.Saliency},'Low')).Dprime];
%Late silencing
Lu = [BehLat(strcmp({BehLat.Modality},'Visual') & strcmp({BehLat.Side},'Ipsi') & strcmp({BehLat.Task},'tUni') & strcmp({BehLat.Silencing},'Late') & strcmp({BehLat.Saliency},'Low')).Dprime];
%Plot
errorbar([1 2],[nanmedian(Cu) nanmedian(Eu)],[abs(nanmedian(Cu)-prctile(Cu,25)) abs(nanmedian(Eu)-prctile(Eu,25))], [abs(nanmedian(Cu)-prctile(Cu,75)) abs(nanmedian(Eu)-prctile(Eu,75)) ],'Color',[1 .7 .3],'LineWidth',3)
errorbar([1.15 3.15],[nanmedian(Cu) nanmedian(Lu)],[abs(nanmedian(Cu)-prctile(Cu,25)) abs(nanmedian(Lu)-prctile(Lu,25))], [abs(nanmedian(Cu)-prctile(Cu,75)) abs(nanmedian(Lu)-prctile(Lu,75))],'Color',[1 .7 .3],'LineWidth',3)

%MST mice ---------------------------------------------------------------
%Same as previously
Cmfilt = strcmp({BehLat.Modality},'Visual') & strcmp({BehLat.Side},'Ipsi') & strcmp({BehLat.Task},'tMulti') & strcmp({BehLat.Saliency},'Low');
Emfilt = strcmp({BehLat.Modality},'Visual') & strcmp({BehLat.Side},'Ipsi') & strcmp({BehLat.Task},'tMulti') & strcmp({BehLat.Silencing},'Early') & strcmp({BehLat.Saliency},'Low');
Lmfilt = strcmp({BehLat.Modality},'Visual') & strcmp({BehLat.Side},'Ipsi') & strcmp({BehLat.Task},'tMulti') & strcmp({BehLat.Silencing},'Late') & strcmp({BehLat.Saliency},'Low');
Cm = [BehLat(Cmfilt).DprimeCtrl];
Em = [BehLat(Emfilt).Dprime];
Lm = [BehLat(Lmfilt).Dprime];
Cme = [BehLat( Cmfilt & ismember(sessionnum,sessionnum(Emfilt))  ).DprimeCtrl];
Cml = [BehLat( Cmfilt & ismember(sessionnum,sessionnum(Lmfilt))  ).DprimeCtrl];
errorbar([1.1 2.1], [nanmedian(Cme) nanmedian(Em)], [abs(nanmedian(Cme)-prctile(Cme,25)) abs(nanmedian(Em)-prctile(Em,25))], [abs(nanmedian(Cme)-prctile(Cme,75)) abs(nanmedian(Em)-prctile(Em,75))],'Color',[.8 0 .8],'LineWidth',3)
errorbar([1.2 3.2], [nanmedian(Cml) nanmedian(Lm)], [abs(nanmedian(Cml)-prctile(Cml,25)) abs(nanmedian(Lm)-prctile(Lm,25))], [abs(nanmedian(Cml)-prctile(Cml,75)) abs(nanmedian(Lm)-prctile(Lm,75))],'Color',[.8 0 .8],'LineWidth',3)

%Figure format ----------------------------------------------------------
xlim([0 4])
ylim([-0.5 2.8])
xticks([1 2 3])
xticklabels({'Ctrl','Early','Late'})
title('Low saliency left-side visual trials')
legend({'UST early','UST late','MST early','MST late'})

%Stats ------------------------------------------------------------------
%Now done with LME

%% High-saliency ipsi was not silenced

%% Figure S8D: Low saliency tactile contra (High-saliency tactile was not silenced)
figure(); hold on
%UST mice ---------------------------------------------------------------
% There was no tactile silencing for UST mice (no real tactile condition)

%MST mice ---------------------------------------------------------------
Cmfilt = strcmp({BehLat.Side},'Contra') & strcmp({BehLat.Modality},'Tactile') & strcmp({BehLat.Task},'tMulti') & strcmp({BehLat.Saliency},'Low');
Emfilt = strcmp({BehLat.Side},'Contra') & strcmp({BehLat.Modality},'Tactile') & strcmp({BehLat.Task},'tMulti') & strcmp({BehLat.Silencing},'Early') & strcmp({BehLat.Saliency},'Low');
Lmfilt = strcmp({BehLat.Side},'Contra') & strcmp({BehLat.Modality},'Tactile') & strcmp({BehLat.Task},'tMulti') & strcmp({BehLat.Silencing},'Late') & strcmp({BehLat.Saliency},'Low');
Cm = [BehLat(Cmfilt).DprimeCtrl];
Em = [BehLat(Emfilt).Dprime];
Lm = [BehLat(Lmfilt).Dprime];
Cme = [BehLat( Cmfilt & ismember(sessionnum,sessionnum(Emfilt))  ).DprimeCtrl];
Cml = [BehLat( Cmfilt & ismember(sessionnum,sessionnum(Lmfilt))  ).DprimeCtrl];
%Plot
errorbar([1.1 2.1], [nanmedian(Cme) nanmedian(Em)], [abs(nanmedian(Cme)-prctile(Cme,25)) abs(nanmedian(Em)-prctile(Em,25))], [abs(nanmedian(Cme)-prctile(Cme,75)) abs(nanmedian(Em)-prctile(Em,75))],'Color',[.8 0 .8],'LineWidth',3)
errorbar([1.2 3.2], [nanmedian(Cml) nanmedian(Lm)], [abs(nanmedian(Cml)-prctile(Cml,25)) abs(nanmedian(Lm)-prctile(Lm,25))], [abs(nanmedian(Cml)-prctile(Cml,75)) abs(nanmedian(Lm)-prctile(Lm,75))],'Color',[.8 0 .8],'LineWidth',3)

%Figure format ----------------------------------------------------------
xlim([0 4])
ylim([-0.5 2.8])
xticks([1 2 3])
xticklabels({'Ctrl','Early','Late'})
title('Low saliency right-side tactile trials')
legend({'MST early','MST late'})

%Stats ------------------------------------------------------------------
%Now done with LME